'Entnommen aus: http://kampis-elektroecke.de
'und
'http://www.roboternetz.de/community/threads/58123-Auslesen-einer-Nachricht-beim-MCP2515

Function Mcp2515_init()as Byte                                                  '------------- MCP2515 Init -----------------
    Local Cnf1Byte as Byte
    Local TargetBitrate as Word

    TargetBitrate = 250

    'Reset MCP2515 per Software
    Reset CAN_CS
    Waitus 100
    McpT = Spi_reset
    Spdr = McpT : Do : Loop Until Spsr.spif = 1
    Waitus 100
    Set CAN_CS
    waitus 10
    'Setup Bit Timing. See kvaser.com/support/calculators/bit-timing-calculator/

    'CAN-SPI Modul der Fa. Mikroelktronika hat einen 16MHz Oszillator
    '125KBit CNF1:07  CNF2:90  CNF3:02
    '250KBit CNF1:03  CNF2:90  CNF3:02
    '500KBit CNF1:01  CNF2:90  CNF3:02
    '1MBit   CNF1:00  CNF2:90  CNF3:02

    Select Case TargetBitrate
     Case 125 : Cnf1Byte = &H07
     Case 250 : Cnf1Byte = &H03
     Case 500 : Cnf1Byte = &H01
     Case 1000 : Cnf1Byte = &H00
    end select
    Mcp2515_write_register Cnf1 , Cnf1Byte
    Mcp2515_write_register Cnf2 , &H90
    Mcp2515_write_register Cnf3 , &H02

    'Setup Interrupt  0 and 1
    Mcp2515_write_register Caninte , &B00000011

    'test if we could read back the value => is the chip accessiblePrint
    if mcp2515_read_register(CNF1) <> Cnf1Byte then
      Mcp2515_init = 0
      Exit Function
    end if

    'deaktivate the RXnBF Pins(High Impedance State)
    mcp2515_write_register BFPCTRL , 0

    'set TXnRTS as inputs
    mcp2515_write_register TXRTSCTRL , 0

    'Setup Filter
    'Buffer 0: Receive all Messages
    Mcp2515_write_register Rxb0ctrl , &B01100000

    'Buffer 1: Receive all Messages
    Mcp2515_write_register Rxb1ctrl , &B01100000

    'Clear all Bits to receive all messages
    Mcp2515_write_register Rxm0sidh , 0
    Mcp2515_write_register Rxm0sidl , 0
    Mcp2515_write_register Rxm0eid8 , 0
    Mcp2515_write_register Rxm0eid0 , 0

    Mcp2515_write_register Rxm1sidh , 0
    Mcp2515_write_register Rxm1sidl , 0
    Mcp2515_write_register Rxm1eid8 , 0
    Mcp2515_write_register Rxm1eid0 , 0

    'Setup Pin Functions
    'Deactivate RXnBF Pins (High Impedance State)
    Mcp2515_write_register Bfpctrl , 0
    'Setup TXnRTS Bits as Input
    Mcp2515_write_register Txrtsctrl , 0

    'Put Device into normal mode
    Mcp2515_bitmodify Canctrl , &B11100000 , &B00000000

    Mcp2515_init = 1
End Function

'-------------- MCP2515 Write ----------------------------
Sub Mcp2515_Write_Register(byval Adress As Byte , Byval Daten As Byte)
    'Print "Reg: " ; Adress ; " Val: " ; Daten
    Reset CAN_CS
    Waitus 1
    McpT = Spi_write
    Spdr = McpT : Do : Loop Until Spsr.spif = 1
    Spdr = Adress : Do : Loop Until Spsr.spif = 1
    Spdr = Daten : Do : Loop Until Spsr.spif = 1
    Set CAN_CS
End Sub

'-------------- MCP2515 Read ----------------------------
Function Mcp2515_Read_Register(byval Adress As Byte) as Byte
    Local CANin as Byte

    Reset CAN_CS
    McpT = Spi_read
    Spdr = McpT : Do : Loop Until Spsr.spif = 1
    Waitus 1
    Spdr = Adress : Do : Loop Until Spsr.spif = 1
    Spdr = 0 : Do : Loop Until Spsr.spif = 1
    CANin = Spdr
    Set CAN_CS
    Mcp2515_read_Register = CANin
End Function

'-------------- MCP2515  BitModify ----------------------------
Sub Mcp2515_Bitmodify(reg_add , Reg_mask , Reg_val)
    Reset CAN_CS
    McpT = Spi_bit_modify
    Spdr = McpT : Do : Loop Until Spsr.spif = 1
    Waitus 1
    Spdr = Reg_add : Do : Loop Until Spsr.spif = 1
    Spdr = Reg_mask : Do : Loop Until Spsr.spif = 1
    Spdr = Reg_val : Do : Loop Until Spsr.spif = 1
    Set CAN_CS
End Sub

Function mcp2515_read_status(byval _type as Byte)as Byte
  Local i as Byte

  Reset CAN_CS
  i = spi_PutByte(_type)
  i = spi_PutByte(&HFF)
  Set CAN_CS
  mcp2515_read_status = i
end Function

'check if there are any new messages waiting
Function mcp2515_check_message() as Byte
  Local i as Byte

  i = CAN_Int
  If i = 0 then
   mcp2515_check_message = 1
  else
   mcp2515_check_message = 0
  end if
end function

'check if there is a free buffer to send messages
Function mcp2515_check_free_buffer(void) as Byte
  Local status as Byte

  status = mcp2515_read_status(SPI_READ_STATUS)
  status = status and &H54
  if status = &H54 then
    mcp2515_check_free_buffer = 0                                               'all buffers used
  else
    mcp2515_check_free_buffer = 1
  end if
end function

Function mcp2515_get_message() as Byte
  Local status as Byte
  Local addr as Byte
  Local i as Byte
  Local Hilf_1 As Word
  Local Hilf_2 As Word
  Local Idh_Tx As Byte
  Local Idl_Tx As Byte
  Local Wd as Word

  'read status
  status = mcp2515_read_status(SPI_RX_STATUS)
  if status.6 = 1 then
    'message in buffer 0
    addr = SPI_READ_RX
  elseif status.7 = 1 then
    'message in buffer 1
    addr = SPI_READ_RX or &H04
  else
    'Error: no message available
    Goto FuncExit
  end if

  RESET CAN_CS
  i = spi_putByte(addr)

  'Read id
  i = spi_putByte(&HFF)

  Hilf_1 = i
  shift Hilf_1 , Left , 3

  i = spi_putByte(&HFF)

  Hilf_2 = i
  shift Hilf_2 , right , 5

  Rx_ID = Hilf_2 + Hilf_1

  'Skip extended
  i = spi_putByte(&HFF)
  i = spi_putByte(&HFF)

  'Read length, is 8
  i = spi_putByte(&HFF)

  'Read Mapping
  Rx_Map = spi_putByte(&HFF)

  'Read Parameter
  Rx_Param_H = spi_putByte(&HFF)
  Rx_Param_L = spi_putByte(&HFF)

  'Read Parameter Offset
  Rx_Ofs = spi_putByte(&HFF)

  'Read 4 data
  for i = 1 to 4
    Rx_D(i) = spi_putByte(&HFF)
  next
  SET CAN_CS

  if Status.6 = 1 then
    Call mcp2515_bitmodify(CANINTF , &B00000001 , 0)
  elseif Status.7 = 1 then
    Call mcp2515_bitmodify(CANINTF , &B00000010 , 0)
  else
  end if

  i = status and &H07
  Incr i
  mcp2515_get_message = i
  Exit Function

FuncExit:
  mcp2515_get_message = 0
end function

Function mcp2515_send_message(byval ID_ as Word , byval Parnum as Word , _
                              byval Ofs as Byte , byval Map as Byte , _
                              byval D1 as Byte , byval D2 as Byte , _
                              byval D3 as Byte , byval D4 as Byte) as Byte
  Local address as Byte
  Local i as Byte
  Local Hilf_1 As Word
  Local Idh_Tx As Byte
  Local Idl_Tx As Byte
  Local SPI_rts as Byte
  Local Parnum_h as Byte
  Local Parnum_l as Byte
  Local Status as Byte

  'read status
  Status = mcp2515_read_status(SPI_RX_STATUS)
  '(
  Statusbyte:
      Bit      Function
      2        TXB0CNTRL.TXREQ
      4        TXB1CNTRL.TXREQ
      6        TXB2CNTRL.TXREQ
')

  if Status.2 = 0 then
    Mcp2515_bitmodify TXB0CTRL , &B0000_0011 , &H11                             'Highest priority
    address = TXB0SIDH
    SPI_rts = Spi_rts0
  elseif Status.4 = 0 then
    Mcp2515_bitmodify TXB1CTRL , &B0000_0011 , &H10                             'Medium priority
    address = TXB1SIDH
    SPI_rts = Spi_rts1
  elseif Status.6 = 0 then
    Mcp2515_bitmodify TXB2CTRL , &B0000_0011 , &H10                             'Low priority
    address = TXB2SIDH
    SPI_rts = Spi_rts2
  else
    'all buffer used => could not send message
    mcp2515_send_message = 0
  end if

  RESET CAN_CS
  Spdr = Spi_write : Do : Loop Until Spsr.spif = 1                              'write command to follow
  Spdr = address : Do : Loop Until Spsr.spif = 1                                'Starting address

  Hilf_1 = Id_
  shift Hilf_1 , right , 3
  Idh_Tx = Hilf_1

  Hilf_1 = Id_                                                                  'and &H07
  shift Hilf_1 , left , 5
  Idl_Tx = Hilf_1

  Spdr = Idh_Tx : Do : Loop Until Spsr.spif = 1
  Spdr = Idl_Tx : Do : Loop Until Spsr.spif = 1

  'Skip extended
  Spdr = 0 : Do : Loop Until Spsr.spif = 1                                      'write command to follow
  Spdr = 0 : Do : Loop Until Spsr.spif = 1                                      'write command to follow

  'Datalength, RTR is set to zero
  Spdr = 8 : Do : Loop Until Spsr.spif = 1

  'Map
  Spdr = Map : Do : Loop Until Spsr.spif = 1

  'Parameter
  Parnum_l = Parnum and &H00FF
  Hilf_1 = Parnum
  shift Hilf_1 , right , 8
  Parnum_h = Hilf_1

  Spdr = Parnum_l : Do : Loop Until Spsr.spif = 1
  Spdr = Parnum_h : Do : Loop Until Spsr.spif = 1

  'Parameter offset
  Spdr = Ofs : Do : Loop Until Spsr.spif = 1

  '4 data byte
  Spdr = D1 : Do : Loop Until Spsr.spif = 1
  Spdr = D2 : Do : Loop Until Spsr.spif = 1
  Spdr = D3 : Do : Loop Until Spsr.spif = 1
  Spdr = D4 : Do : Loop Until Spsr.spif = 1

  SET CAN_CS

  'actually send message now
  Reset CAN_CS
  Waitus 1
  Spdr = SPI_rts : Do : Loop Until Spsr.spif = 1
  Waitus 1
  Set CAN_CS

  Timer1 = 0
  Do
    If Timer1 > 5msTimeout then
       mcp2515_send_message = 0
       Exit Function
    End If
  Loop until CAN_Int = 0
  i = mcp2515_get_message()
  mcp2515_send_message = 1
end function