'Entnommen aus: http://kampis-elektroecke.de
'und
'http://www.roboternetz.de/community/threads/58123-Auslesen-einer-Nachricht-beim-MCP2515

Dim IntValid as Byte
Dim Old_CAN_Int as Byte
Dim Act_CAN_Int as Byte

Declare Function TxRxError() as String

Declare Sub MCP2515_Write_Register(byval Adress As Byte , Byval Daten As Byte)

Declare Function Mcp2515_Read_Register(byval Adress As Byte) as Byte

Declare Sub MCP2515_bitmodify(Byval Reg_add As Byte , _
                              Byval Reg_mask As Byte , _
                              Byval Reg_val As Byte)

Declare Function Mcp2515_init()as Byte

Declare Function mcp2515_read_status(byval _type as Byte)as Byte

'check if there are any new messages waiting
Declare Function mcp2515_check_message() as Byte

'check if there is a free buffer to send messages
Declare Function mcp2515_check_free_buffer() as Byte

Declare Function mcp2515_get_message() as Byte

Declare Function mcp2515_send_message(byval ID_ as Word , byval Parnum as Word , _
                                      byval Ofs as Byte , byval Map as Byte , _
                                      byval D1 as Byte , byval D2 as Byte , _
                                      byval D3 as Byte , byval D4 as Byte) as Byte

'Adressen der Register des MCP2515. Die Redundanten Adressen von z.B. dem Register CANSTAT
' (0x0E, 0x1E, 0x2E, ...) wurden dabei nicht mit aufgelistet

Const RXF0SIDH = &H00
Const RXF0SIDL = &H01
Const RXF0EID8 = &H02
Const RXF0EID0 = &H03
Const RXF1SIDH = &H04
Const RXF1SIDL = &H05
Const RXF1EID8 = &H06
Const RXF1EID0 = &H07
Const RXF2SIDH = &H08
Const RXF2SIDL = &H09
Const RXF2EID8 = &H0A
Const RXF2EID0 = &H0B
Const BFPCTRL = &H0C
Const TXRTSCTRL = &H0D
Const CANSTAT = &H0E
Const CANCTRL = &H0F

Const RXF3SIDH = &H10
Const RXF3SIDL = &H11
Const RXF3EID8 = &H12
Const RXF3EID0 = &H13
Const RXF4SIDH = &H14
Const RXF4SIDL = &H15
Const RXF4EID8 = &H16
Const RXF4EID0 = &H17
Const RXF5SIDH = &H18
Const RXF5SIDL = &H19
Const RXF5EID8 = &H1A
Const RXF5EID0 = &H1B
Const TEC = &H1C
Const REC = &H1D

Const RXM0SIDH = &H20
Const RXM0SIDL = &H21
Const RXM0EID8 = &H22
Const RXM0EID0 = &H23
Const RXM1SIDH = &H24
Const RXM1SIDL = &H25
Const RXM1EID8 = &H26
Const RXM1EID0 = &H27
Const CNF3 = &H28
Const CNF2 = &H29
Const CNF1 = &H2A
Const CANINTE = &H2B
Const CANINTF = &H2C
Const EFLG = &H2D

Const TXB0CTRL = &H30
Const TXB0SIDH = &H31
Const TXB0SIDL = &H32
Const TXB0EID8 = &H33
Const TXB0EID0 = &H34
Const TXB0DLC = &H35
Const TXB0D0 = &H36
Const TXB0D1 = &H37
Const TXB0D2 = &H38
Const TXB0D3 = &H39
Const TXB0D4 = &H3A
Const TXB0D5 = &H3B
Const TXB0D6 = &H3C
Const TXB0D7 = &H3D

Const TXB1CTRL = &H40
Const TXB1SIDH = &H41
Const TXB1SIDL = &H42
Const TXB1EID8 = &H43
Const TXB1EID0 = &H44
Const TXB1DLC = &H45
Const TXB1D0 = &H46
Const TXB1D1 = &H47
Const TXB1D2 = &H48
Const TXB1D3 = &H49
Const TXB1D4 = &H4A
Const TXB1D5 = &H4B
Const TXB1D6 = &H4C
Const TXB1D7 = &H4D

Const TXB2CTRL = &H50
Const TXB2SIDH = &H51
Const TXB2SIDL = &H52
Const TXB2EID8 = &H53
Const TXB2EID0 = &H54
Const TXB2DLC = &H55
Const TXB2D0 = &H56
Const TXB2D1 = &H57
Const TXB2D2 = &H58
Const TXB2D3 = &H59
Const TXB2D4 = &H5A
Const TXB2D5 = &H5B
Const TXB2D6 = &H5C
Const TXB2D7 = &H5D

Const RXB0CTRL = &H60
Const RXB0SIDH = &H61
Const RXB0SIDL = &H62
Const RXB0EID8 = &H63
Const RXB0EID0 = &H64
Const RXB0DLC = &H65
Const RXB0D0 = &H66
Const RXB0D1 = &H67
Const RXB0D2 = &H68
Const RXB0D3 = &H69
Const RXB0D4 = &H6A
Const RXB0D5 = &H6B
Const RXB0D6 = &H6C
Const RXB0D7 = &H6D

Const RXB1CTRL = &H70
Const RXB1SIDH = &H71
Const RXB1SIDL = &H72
Const RXB1EID8 = &H73
Const RXB1EID0 = &H74
Const RXB1DLC = &H75
Const RXB1D0 = &H76
Const RXB1D1 = &H77
Const RXB1D2 = &H78
Const RXB1D3 = &H79
Const RXB1D4 = &H7A
Const RXB1D5 = &H7B
Const RXB1D6 = &H7C
Const RXB1D7 = &H7D

'Bitdefinition der verschiedenen Register

'Bitdefinition von BFPCTRL
Const B1BFS = 5
Const B0BFS = 4
Const B1BFE = 3
Const B0BFE = 2
Const B1BFM = 1
Const B0BFM = 0

'Bitdefinition von TXRTSCTRL
Const B2RTS = 5
Const B1RTS = 4
Const B0RTS = 3
Const B2RTSM = 2
Const B1RTSM = 1
Const B0RTSM = 0

'Bitdefinition von CANSTAT
Const OPMOD2 = 7
Const OPMOD1 = 6
Const OPMOD0 = 5
Const ICOD2 = 3
Const ICOD1 = 2
Const ICOD0 = 1

'Bitdefinition von CANCTRL
Const REQOP2 = 7
Const REQOP1 = 6
Const REQOP0 = 5
Const ABAT = 4
Const CLKEN = 2
Const CLKPRE1 = 1
Const CLKPRE0 = 0

'Bitdefinition von CNF3
Const WAKFIL = 6
Const PHSEG22 = 2
Const PHSEG21 = 1
Const PHSEG20 = 0

'Bitdefinition von CNF2
Const BTLMODE = 7
Const SAM = 6
Const PHSEG12 = 5
Const PHSEG11 = 4
Const PHSEG10 = 3
Const PHSEG2 = 2
Const PHSEG1 = 1
Const PHSEG0 = 0

'Bitdefinition von CNF1
Const SJW1 = 7
Const SJW0 = 6
Const BRP5 = 5
Const BRP4 = 4
Const BRP3 = 3
Const BRP2 = 2
Const BRP1 = 1
Const BRP0 = 0

'Bitdefinition von CANINTE
Const MERRE = 7
Const WAKIE = 6
Const ERRIE = 5
Const TX2IE = 4
Const TX1IE = 3
Const TX0IE = 2
Const RX1IE = 1
Const RX0IE = 0

'Bitdefinition von CANINTF
Const MERRF = 7
Const WAKIF = 6
Const ERRIF = 5
Const TX2IF = 4
Const TX1IF = 3
Const TX0IF = 2
Const RX1IF = 1
Const RX0IF = 0

'Bitdefinition von EFLG
Const RX1OVR = 7
Const RX0OVR = 6
Const TXB0 = 5
Const TXEP = 4
Const RXEP = 3
Const TXWAR = 2
Const RXWAR = 1
Const EWARN = 0

'Bitdefinition von TXBnCTRL(n = 0 , 1 , 2)
Const ABTF = 6
Const MLOA = 5
Const TXERR = 4
Const TXREQ = 3
Const TXP1 = 1
Const TXP0 = 0

'Bitdefinition von RXB0CTRL
Const RXM1 = 6
Const RXM0 = 5
Const RXRTR = 3
Const BUKT = 2
Const BUKT1 = 1
Const FILHIT0 = 0

'Bitdefinition von TXBnSIDL (n = 0, 1)
Const EXIDE = 3

'Bitdefinition von RXB1CTRL
'    RXM1, RXM0, RXRTR und FILHIT0 sind schon fuer RXB0CTRL definiert

Const FILHIT2 = 2
Const FILHIT1 = 1

'Bitdefinition von RXBnSIDL(n = 0 , 1)
Const SRR = 4
Const IDE = 3

'Bitdefinition von RXBnDLC (n = 0, 1) see TXBnDLC   (gleiche Bits)
Const RTR = 6
Const DLC3 = 3
Const DLC2 = 2
Const DLC1 = 1
Const DLC0 = 0