'(
************************************

Dieser Sourcecode wird verffentlicht ohne Gewhr!
Matthias Walter in 2015

LockBit , FuseBitLow , FuseBitHigh , FuseBitExtended
')
'$prog &HFF , &HE7 , &HD9 , &HFF
'(
Siehe http://eleccelerator.com/fusecalc/fusecalc.phpPrint chip = atmega644pa
BOOTSZ = egal
BROWN -OUT / BODLEVEL = disabled
OCDEN = Disabled
JTAGEN = Disabled
SPIEN = Enabled
WDTON = Disabled
EESAVE = Disabled
CKDIV8 = Disabled
CKOUT = Disabled
BOOTRST = Disabled
RSTDISBL = Disabled
DWEN = uncheDisabledcked
SUT_CKSEL = EXTFSXTAL_16KCK+4.1MS
')

$regfile = "m644Pdef.dat"                                                       'ATMEGA644PA CPU   "PA" = (P)ico Power, (A)zweite Revision
Const F_Cpu = 20000000
$framesize = 64
$swstack = 64
$hwstack = 64
$crystal = F_CPU
$baud = 57600                                                                   'No parity, 1 stop bit, 8 data bits

$include "Header_MCP2515.bas"
$include "Header_SPI.bas"

'      PORTD.0 = RXD
'      PORTD.1 = TXD
Config Portd.2 = Input                                                          'CAN_INT. Pullup MUSS eingeschaltet werden, siehe unten
CAN_Int alias PIND.2

Config Portd.3 = Output                                                         'CAN_CS
CAN_CS Alias Portd.3

Dim 5msTimeout as Integer

'****************** CAN *******************
Dim McpT As Byte
Dim Rx_ID as Word
Dim Rx_Map as Byte

Dim Rx_Param as Word
Dim Rx_Param_H as Word at Rx_Param + 0 overlay
Dim Rx_Param_L as Word at Rx_Param + 1 overlay

Dim Rx_Ofs as Byte
Dim Rx_D(4) as Byte

Dim Rx_int32 as Long at Rx_D(1) overlay
Dim Rx_uint32 as DWord at Rx_D(1) overlay
Dim Rx_uint16_1 as Word at Rx_D(1) overlay
Dim Rx_uint8_1 as Byte at Rx_D(1) overlay

Dim Rx_int16_1 as Integer at Rx_D(1) overlay
Dim Rx_int16_2 as Integer at Rx_D(3) overlay

'****************** CAN *******************

Dim Ldummy As Long
Dim Ldummy_1 As Byte At Ldummy + 0 Overlay
Dim Ldummy_2 As Byte At Ldummy + 1 Overlay
Dim Ldummy_3 As Byte At Ldummy + 2 Overlay
Dim Ldummy_4 As Byte At Ldummy + 3 Overlay

dim DWdummy as Dword
Dim DWdummy_1 As Byte At DWdummy + 0 Overlay
Dim DWdummy_2 As Byte At DWdummy + 1 Overlay
Dim DWdummy_3 As Byte At DWdummy + 2 Overlay
Dim DWdummy_4 As Byte At DWdummy + 3 Overlay

'-------------------------------- SPI -----------------------------------------
Spcr = &B0101_0001                                                              'SPI Control Register
'        |||| ||01 Prescaler = 4
'        |||| ||01 Prescaler = 16
'        |||| ||10 Prescaler = 64
'        |||| ||11 Prescaler = 128
'        |||| ||00 Prescaler = 2  Wenn SPSR, Bit0 = 1
'        |||| ||01 Prescaler = 8  Wenn SPSR, Bit0 = 1
'        |||| ||10 Prescaler = 32 Wenn SPSR, Bit0 = 1
'        |||| ||11 Prescaler = 64 Wenn SPSR, Bit0 = 1
'        |||| |0   Clock Phase 0 = Leading  1 = Trailing
'        |||| 0    Clock Polarity 0 = Rising  1 = Falling
'        |||1      Master = 1  Slave = 0
'        ||0       Data order MSB = 0, LSB = 1
'        |1        SPI enable (NOSS)
'        0         SPI Interrupt enable

SpSr = &B0000_0000                                                              'SPI Status Register
'        |||| |||1 Double Speed Prescaler
'        |||| ||x  not used
'        |||| |x   not used
'        |||| x    not used
'        |||x      not used
'        ||x       not used
'        |x        Write Collision Flag is set until Tx is done
'        x         Transmit complete Interrupt flag at end of Tx

'SPDR Data read/Write Register
'-------------------------------- SPI -----------------------------------------

Config Timer1 = Timer , Prescale = 1024                                         '51,2uS / Tick maximal 65535 Ticks
' "Enable Timer1" nicht erforderlich weil der Timerberlauf nicht ausgewertet wird

Dim Wd as word
Dim L1 as long
Dim L2 as long

Wd = F_Cpu \ 1024
L1 = 1000000 \ Wd                                                               'uS
L2 = 5000 \ L1
5msTimeout = L2                                                                 'Timer Ticks

Enable Interrupts

if Mcp2515_init() = 0 then Print "Error initiating MCP2515"

Ldummy = 30000                                                                  'in mA
If MCP2515_send_message(&H601 , &H3221 , &H00 , &H32 , _
                        Ldummy_1 , Ldummy_2 , Ldummy_3 , Ldummy_4) = 1 then     'uint32 write Positive Current Limit
   'nothing
end if

Ldummy = 10000                                                                  'in mA
If MCP2515_send_message(&H601 , &H3223 , &H00 , &H32 , _
                        Ldummy_1 , Ldummy_2 , Ldummy_3 , Ldummy_4) = 1 then     'uint32 write Negative Current Limit
   'nothing
end if

If MCP2515_send_message(&H601 , &H3004 , &H00 , &H23 , _
                        &H01 , &H00 , &H00 , &H00) = 1 then                     'uint8 RUN senden
   'nothing
end if

Ldummy = 1200                                                                   'in mA
If MCP2515_send_message(&H601 , &H3200 , &H00 , &H32 , _
                        LDummy_1 , LDummy_2 , LDummy_3 , LDummy_4) = 1 then     'Stromsollwert an FU senden
   'nothing
end if

If MCP2515_send_message(&H601 , &H3111 , &H00 , &H40 , _
                        &H00 , &H00 , &H00 , &H00) = 1 then                     'Versorgungsspannung lesen
   If Rx_ID = &H581 then
      Print "Voltage: " ; Rx_uint32 ; " mV"
   else
      PRINT "Fehler: konnte die Nachricht nicht senden/empfangen"
   end if
else
   'Fehler
End If

If MCP2515_send_message(&H601 , &H3113 , &H00 , &H40 , _
                        &H00 , &H00 , &H00 , &H00) = 1 then                     'Motorstrom lesen
   If Rx_ID = &H581 then
       Print "Motor Current: " ; Rx_int32 ; " mA"
   else
       PRINT "Fehler: konnte die Nachricht nicht senden/empfangen"
   end if
else
   'Fehler
End If

$include "Body_MCP2515.bas"
$include "Body_SPI.bas"